go.modules.business.kanban.ColumnDialog = Ext.extend(go.Window, {
    title: t("Column"),
    width: dp(400),
    height: dp(300),
    layout: "fit",

    index : -1,

    constructor: function(list) {
        this.list = list;
        go.modules.business.kanban.ColumnDialog.superclass.constructor.call(this);
    },

    initComponent: function () {

        this.items = [this.form = new Ext.form.FormPanel({
            items:[{
                xtype: 'fieldset',
                items: [{
                    xtype: 'hidden',
                    name: 'id'
                },{
                    xtype: 'textfield',
                    allowBlank: false,
                    fieldLabel: t("Name"),
                    name: 'name',
                    anchor: '100%'
                },{
                    xtype: 'colorfield',
                    name: 'color',
                    fieldLabel: t("Color"),
                    anchor: '100%'
                },{
                    xtype: 'selectfield',
                    hiddenName: 'progressChange',
                    fieldLabel: t("Progress"),
                    hint: t('Changes the progress of the task'),
                    anchor: '100%',
                    options: [
                        ['in-progress', t('In Progress')],
                        ['completed', t('Completed')],
                        ['failed', t('Failed')]
                    ]
                }]
            }]
        })];

        this.buttons = [
            '->', {
                text: t('Save'),
                handler: function () {
                    var params = {groups: this.list.groups},
                        group = this.form.form.getValues();

                    if (this.index == -1) { // new
                        delete group.id;
                        params.groups.push(group);
                    } else {
                        params.groups[this.index] = group;
                    }

                    go.Db.store('Tasklist').set({update:{[this.list.id]:params}}, function() {
                        this.close();
                    },this);
                },
                scope:this
            }
        ];

        go.modules.business.kanban.ColumnDialog.superclass.initComponent.call(this);
    },

    load: function(groupId) {
        this.isNew = false;
        for(var i=0; i < this.list.groups.length; i++) {
            if(this.list.groups[i].id == groupId) {
                this.index = i;
                console.log(this.list.groups[i]);
                this.form.form.setValues(this.list.groups[i]);
                break;
            }
        }
    }
});
