go.modules.business.kanban.ColumnDropZone = Ext.extend(Ext.dd.DropZone, {
    proxyOffsets : [-3, -6],
    fly: Ext.Element.fly,

    constructor : function(board, hd, hd2){
        this.board = board;
       // this.view = grid.getView();

        this.proxyTop = Ext.DomHelper.append(document.body, {
            cls:"col-move-top", html:"&#160;"
        }, true);
        this.proxyBottom = Ext.DomHelper.append(document.body, {
            cls:"col-move-bottom", html:"&#160;"
        }, true);
        this.proxyTop.hide = this.proxyBottom.hide = function(){
            this.setLeftTop(-100,-100);
            this.setStyle("visibility", "hidden");
        };
        this.ddGroup = "boardHeader" + this.board.getEl().id;

        go.modules.business.kanban.ColumnDropZone.superclass.constructor.call(this, board.getEl().dom);
    },

    getTargetFromEvent : function(e){
        var t = Ext.lib.Event.getTarget(e),
            panel = Ext.get(t).parent('.x-panel');
        if(panel.dom != panel.dom.parentElement.firstChild) // backlog
            return panel.dom.firstChild; // header
    },

    positionIndicator : function(h, n, e){
        var x = Ext.lib.Event.getPageX(e),
            r = Ext.lib.Dom.getRegion(n),
            px,
            pt,
            py = r.top + this.proxyOffsets[1];
        if((r.right - x) <= (r.right-r.left)/2){
            px = r.right;
            pt = "after";
        }else{
            px = r.left;
            pt = "before";
        }

        px +=  this.proxyOffsets[0];
        this.proxyTop.setLeftTop(px, py);
        this.proxyTop.show();
        if(!this.bottomOffset){
            this.bottomOffset = 32; // todo make height of panel header?
        }
        this.proxyBottom.setLeftTop(px, py+this.proxyTop.dom.offsetHeight+this.bottomOffset);
        this.proxyBottom.show();
        return pt;
    },

    onNodeEnter : function(n, dd, e, data){
        if(data.header != n && n.classList.contains('x-panel-header')){
            this.positionIndicator(data.header, n, e);
        }
    },

    onNodeOver : function(n, dd, e, data){
        var result = false;
        if(data.header != n && n.classList.contains('x-panel-header')){
            result = this.positionIndicator(data.header, n, e);
        }
        if(!result){
            this.proxyTop.hide();
            this.proxyBottom.hide();
        }
        return result ? this.dropAllowed : this.dropNotAllowed;
    },

    onNodeOut : function(n, dd, e, data){
        this.proxyTop.hide();
        this.proxyBottom.hide();
    },

    onNodeDrop : function(n, dd, e, data){
        var h = data.header;
        if(h != n){
            var x = Ext.lib.Event.getPageX(e),
                r = Ext.lib.Dom.getRegion(n),
                pt = (r.right - x) <= ((r.right-r.left)/2) ? "after" : "before",
                oldIndex = this.board.getColumnIndex(h),
                newIndex = this.board.getColumnIndex(n);
            if(pt == "after"){
                newIndex++;
            }
            if(oldIndex < newIndex){
                newIndex--;
            }
            this.board.moveColumn(oldIndex, newIndex);
            return true;
        }
        return false;
    }
});